;
; FPATCH2 functionality as GFABASIC INLINE
; from disassembled FPATCH2.PRG
;
; (c) 2008 by Simon Sunnyboy / Paradize   http://paradize.atari.org/
;
; call the code with XBIOS 38 or while being in SUPERVISOR
;
; version with Falcon detection via Cookie Jar and flag to
; show whether the FPATCH was applied
;
                    OPT O+
                    OPT P+

                    >PART 'equates'
gemdos              EQU 1
bios                EQU 13
xbios               EQU 14

reset_ssp           EQU 0
reset_pc            EQU 4
bus_err             EQU 8
adr_err             EQU $0C
ille_exc            EQU $10
div0_exc            EQU $14
chk_exc             EQU $18
trapv_exc           EQU $1C
priv_exc            EQU $20
trac_exc            EQU $24
linea_exc           EQU $28
linef_exc           EQU $2C
noini_exc           EQU $3C
falsi_exc           EQU $60
aut1_exc            EQU $64
aut2_exc            EQU $68
aut3_exc            EQU $6C
aut4_exc            EQU $70
aut5_exc            EQU $74
aut6_exc            EQU $78
aut7_exc            EQU $7C
tr0_exc             EQU $80
tr1_exc             EQU $84
tr2_exc             EQU $88
tr3_exc             EQU $8C
tr4_exc             EQU $90
tr5_exc             EQU $94
tr6_exc             EQU $98
tr7_exc             EQU $9C
tr8_exc             EQU $A0
tr9_exc             EQU $A4
tra_exc             EQU $A8
trb_exc             EQU $AC
trc_exc             EQU $B0
trd_exc             EQU $B4
tre_exc             EQU $B8
trf_exc             EQU $BC
parr_port           EQU $0100
rs232_dcd           EQU $0104
rs232_cts           EQU $0108
grphblitok          EQU $010C
rs232_baud          EQU $0110
key_midi            EQU $0118
fdc_hdc             EQU $011C
h_blank             EQU $0120
rs232_terr          EQU $0124
rs232_tbuf          EQU $0128
rs232_rerr          EQU $012C
rs232_rbuf          EQU $0130
timer_a             EQU $0134
rs232_ring          EQU $0138
mono_dtct           EQU $013C
proc_lives          EQU $0380
proc_regs           EQU $0384
proc_pc             EQU $03C4
proc_usp            EQU $03C8
proc_stk            EQU $03CC
etv_timer           EQU $0400
etv_critic          EQU $0404
etv_term            EQU $0408
etv_xtra            EQU $040C
memvalid            EQU $0420
memcntlr            EQU $0424
resvalid            EQU $0426
resvector           EQU $042A
phystop             EQU $042E
_membot             EQU $0432
_memtop             EQU $0436
memval2             EQU $043A
flock               EQU $043E
seekrate            EQU $0440
_timr_ms            EQU $0442
_fverify            EQU $0444
_bootdev            EQU $0446
palmode             EQU $0448
defshiftmd          EQU $044A
sshiftmd            EQU $044C
_v_bas_ad           EQU $044E
vblsem              EQU $0452
nvbls               EQU $0454
_vblqueue           EQU $0456
colorptr            EQU $045A
screenpt            EQU $045E
_vbclock            EQU $0462
_frclock            EQU $0466
hdv_init            EQU $046A
swv_vec             EQU $046E
hdv_bpb             EQU $0472
hdv_rw              EQU $0476
hdv_boot            EQU $047A
hdv_mediach         EQU $047E
_cmdload            EQU $0482
conterm             EQU $0484
trp14ret            EQU $0486
criticret           EQU $048A
themd               EQU $048E
_____md             EQU $049E
savptr              EQU $04A2
_nflops             EQU $04A6
con_state           EQU $04A8
save_row            EQU $04AC
sav_context         EQU $04AE
_bufl1              EQU $04B2
_bufl2              EQU $04B6
_hz_200             EQU $04BA
th_env              EQU $04BC
_drvbits            EQU $04C2
_dskbufp            EQU $04C6
_autopath           EQU $04CA
_vbl_list           EQU $04CE
_dumpflg            EQU $04EE
_prtabt             EQU $04F0
_sysbase            EQU $04F2
_shell_p            EQU $04F6
end_os              EQU $04FA
exec_os             EQU $04FE
scr_dump            EQU $0502
prv_lsto            EQU $0506
prv_lst             EQU $050A
prv_auxo            EQU $050E
prv_aux             EQU $0512
a_init              EQU $A000
a_putpix            EQU $A001
a_getpix            EQU $A002
a_abline            EQU $A003
a_habline           EQU $A004
a_rectfill          EQU $A005
a_polyfill          EQU $A006
a_bitblt            EQU $A007
a_textblt           EQU $A008
a_showcur           EQU $A009
a_hidecur           EQU $A00A
a_chgcur            EQU $A00B
a_drsprite          EQU $A00C
a_unsprite          EQU $A00D
a_copyrstr          EQU $A00E
a_seedfill          EQU $A00F
memconf             EQU -$7FFF
dbasehi             EQU -$7DFF
dbaselow            EQU -$7DFD
vcounthi            EQU -$7DFB
vcountmid           EQU -$7DF9
vcountlow           EQU -$7DF7
syncmode            EQU -$7DF6
color0              EQU -$7DC0
color1              EQU -$7DBE
color2              EQU -$7DBC
color3              EQU -$7DBA
color4              EQU -$7DB8
color5              EQU -$7DB6
color6              EQU -$7DB4
color7              EQU -$7DB2
color8              EQU -$7DB0
color9              EQU -$7DAE
color10             EQU -$7DAC
color11             EQU -$7DAA
color12             EQU -$7DA8
color13             EQU -$7DA6
color14             EQU -$7DA4
color15             EQU -$7DA2
shiftmd             EQU -$7DA0
diskctl             EQU -$79FC
fifo                EQU -$79FA
dmahigh             EQU -$79F7
dmamid              EQU -$79F5
dmalow              EQU -$79F3
giread              EQU -$7800
giwrite             EQU -$77FE
gpip                EQU -$05FF
aer                 EQU -$05FD
ddr                 EQU -$05FB
iera                EQU -$05F9
ierb                EQU -$05F7
ipra                EQU -$05F5
iprb                EQU -$05F3
isra                EQU -$05F3
isrb                EQU -$05EF
imra                EQU -$05ED
imrb                EQU -$05EB
vr                  EQU -$05E9
tacr                EQU -$05E7
tbcr                EQU -$05E5
tcdcr               EQU -$05E3
tadr                EQU -$05E1
tbdr                EQU -$05DF
tcdr                EQU -$05DD
tddr                EQU -$05DB
scr                 EQU -$05D9
ucr                 EQU -$05D7
rsr                 EQU -$05D5
tsr                 EQU -$05D3
udr                 EQU -$05D1
keyctl              EQU -$0400
keybd               EQU -$03FE
midictl             EQU -$03FC
midi                EQU -$03FA
                    ENDPART
                    TEXT
                    bra     begin
fpatch2flag:        DC.L 0      ; here we signal successful patch

begin:
                    movem.l D0-A6,-(SP)
                    lea     fpatch2flag(PC),A6
                    move.w  #0,(A6)         ; signal no patch applied

; check for Falcon via Cookie Jar
                    >PART 'check_f030'
                    movea.l $05A0,A0        ; load pointer to cookiejar
                    beq     exit            ; null pointer => ST
cookieloop:
                    move.l  (A0)+,D0        ; get Cookie
                    move.l  (A0)+,D1        ; cookie value
                    cmpi.l  #'_MCH',D0      ; _MCH cookie?
                    beq     check_falcon    ; check if this is a Falcon
                    tst.l   D0              ; check if cookie <>0
                    bne     cookieloop      ; yes..then repreat search
; no.. then no _MCH cookie found => ST
                    bra     exit            ; and out

check_falcon:
                    andi.l  #$FFFF0000,D1   ; mask unneeded cookei bits
                    cmpi.l  #$030000,D1
                    beq     do_patch        ; if Falcon, try to patch
                    bra     exit            ; if not, don't do anything
                    ENDPART
; patch via XBIOS
do_patch:
                    >PART 'do_fpatch2'
                    movea.l _sysbase.w,A0
                    movea.l 8(A0),A0
                    move.w  2(A0),D6
                    sub.w   #etv_timer,D6
                    bmi     already_patched
                    cmp.w   #5,D6
                    bge     already_patched

                    move.w  #1,-(SP)
                    move.w  #reset_ssp,-(SP)
                    move.w  #reset_ssp,-(SP)
                    move.w  #bus_err,-(SP)
                    move.w  #reset_ssp,-(SP)
                    move.w  #$8B,-(SP)
                    trap    #xbios
                    adda.w  #12,SP

                    clr.w   -(SP)
                    move.w  #$80,-(SP)
                    trap    #xbios
                    addq.l  #4,SP

                    move.w  #$40,-(SP)
                    move.w  #2,-(SP)
                    move.w  #$82,-(SP)
                    trap    #xbios
                    move.w  #3,2(SP)
                    trap    #xbios
                    addq.l  #6,SP

                    move.w  #3,-(SP)
                    move.w  #6,-(SP)
                    move.w  #$82,-(SP)
                    trap    #xbios
                    move.w  #4,2(SP)
                    trap    #xbios
                    move.w  #5,2(SP)
                    trap    #xbios
                    addq.w  #6,SP

                    move.w  #$FFFE,-(SP)
                    move.w  #linef_exc,-(SP)
                    trap    #xbios
                    addq.w  #4,SP

                    movea.l D0,A0
                    move.w  4(A0),D0
                    cmp.w   #1,D0
                    bne.s   patch_installed
                    move.w  #3,4(A0)
patch_installed:
; we land here if the patch was successfully applied
already_patched:
                    lea     fpatch2flag(PC),A6
                    move.w  #-1,(A6)        ; signal "patch applied"

                    ENDPART
exit:
                    movem.l (SP)+,D0-A6
                    rts
                    END
